using System;
namespace ConsoleApp2
{
    internal class Program
    {
        static int metoda(int[,] A, int i, int j, int N, int M)
        {
            
            if (i == N || j == M)
            {
                return int.MaxValue;
            }
            else if (i == N - 1 && j == M - 1)
            {
                return A[i, j];
            }
            else
            {
                return A[i, j] + Math.Min(metoda(A, i, j+1, N, M), metoda(A, i+1, j, N, M));
                
            }

        }
        
        static void Main(string[] args)
        {
            int N, M;
            string[] s=Console.ReadLine().Split(' ');
            N=int.Parse(s[0]);
            M=int.Parse(s[1]);
            int[,] A = new int[N, M];
            for (int i = 0; i < N; i++)
            {
                s = Console.ReadLine().Split(' ');
                for (int j = 0; j < s.Length; j++)
                {
                    A[i, j] = int.Parse(s[j]);
                }
            }
            int Q = int.Parse(Console.ReadLine());

            int[,] B = A;
            for (int i = 0; i < Q; i++)
            {
                s=Console.ReadLine().Split(' ');
                int t = B[int.Parse(s[0]) - 1, int.Parse(s[1]) - 1];
                B[int.Parse(s[0]) - 1, int.Parse(s[1]) - 1] = N*M*N*M;
                Console.WriteLine(metoda(B, 0, 0, N, M));
                B[int.Parse(s[0]) - 1, int.Parse(s[1]) - 1] = t;
            }
        }
    }
}